# TODO List
- [ ] example 填充
- [x] 统一设定公开接口，减少不必要的暴露
- [ ] `torch.load()` 指明 `weights_only=True`
- [ ] 重构 parser 逻辑，解决引用相关的问题
- [ ] 只处理 idx_list 的 pipeline 无法记录 idx 的生成方法，可能要用某种方法固化一下
- [ ] `key_points` 应该统一为 `keypoints` 
- [ ] 附带资源可能缺省 annotation file，要不增加缺省的情况，不用额外存储多一个文件
- [x] 需要弃用 `image_path`，改用 `name` 来替代，唯一标识才有用
- [ ] 对比 [fiftyone](https://github.com/voxel51/fiftyone)
    - 用于目标检测的类 pandas 数据集工具，带 UI，值得参考
    - 不过看起来比较复杂，而且还没到稳定版本，不适合自建数据
- [x] 对比 [huggingface](https://github.com/huggingface/datasets)
    - 灵活性较差，放弃
- [x] 考虑添加 segment anything 以及 inpaint anything
    - 添加了 segment anything
- [x] 一个数据集对应多个图像和标注资源似乎会比较方便
    - [ ] 比如说在读数据集的时候可以选择性 load 某些子资源，方便一同处理
    - [ ] 如果有缺失数据的话也方便自定义插值算法，不用专整一个
    - 但是违反了口袋原则，图像库和标签对的一一对应结构应该是最重要的。附加功能可以在更上层考虑
- [x] 考虑数据只读情况设置
    - python 不太可能只读
- [ ] 考虑增加 `processor` 配置读取，至少支持简单的手工复原
- [ ] 断开 PyTorch 依赖
- [ ] `processor` 顺序处理的输出值考虑支持多层嵌套？（当前只支持一层 list 嵌套）
- [ ] 想要一种从一张图像根据内容得出另一张图像相似内容的映射网格的工具（SIFT 图像配准？）
- [ ] 参照下 `imutils` 进行改进以及工程完善
- [ ] 图像信号自适应缩放压缩及混淆检测
	- [ ] 需要能根据几个参数将图片抗混淆地缩放到较小的尺寸以便保存
- [ ] 视频工具需要从 OpenCV 换成别的库，原因见 [[OpenCV#视频]]
- [x] 索引 idx 不利于数据增减，而且目前特定索引困难，应该改为文件名索引方式
    - 添加了文件名索引以及名字和 idx 互换，需要随时保证数据名字和 idx 对齐，有点隐患
- [x] JSON 保存标签有点太大了，对于大数据集来说 I/O 很慢，可以添加一种高效率的序列化格式
	- 可以考虑转成 pandas 再用其他二进制序列化方法
- [ ] 感觉每个 parser 都加一个 version 字段进 parser 属性字典里，然后放到数据集元数据中作为版本控制会挺好
    - 添加了版本字段，但目前暂无规范使用
- [x] 增加一个读取测试用例的工具，会常用到 ^80c1df
- [x] 整合 98 点关键点标注，或许需要将点数加到属性中，并且区分好人脸检测的 `landmarks` 和这类关键点检测的 `landmarks`，也涉及到从中台拿到的标注的区分
	- 目前使用 version 来控制版本，默认版本标注格式固定
- [ ] 目前 ffhq_fast 对齐后的标注和原数据集标注格式有所不同，还是确定统一方法比较合适
	- 在 ffhq 对齐后鼻子的 key_points 被舍弃了（因为没用上），这是导致两类标注格式不同的一大原因，需解决
- [x] 数据集的裁剪格式应该用配置文件来控制版本和参数
	- 目前端上准备通过调整 crop_v3 的三个参数来进行不同需求的裁剪
	- [x] 已完成配置文件 json 输出
	- [x] 版本控制需要再细想一下
		- 目前分数据集和 parser 两个版本
- [x] 标注信息中的 `image_path` 和实际不总是能对上，挺烦恼的，或许和目前 pix2pixHD 工程对数据集存放有特别需求有关，也许需要改进
	- 感觉用标注信息来获取数据路径有点怪怪的，理论上应该转成更高效的数据形式进行训练，现在的情况改为相对路径下的文件名用以调试大概就够了
	- 然后就是限制 parser 的使用（仅限在数据集类中使用）
	- 干脆都改成文件名算了，数据集内文件名唯一，不加路径以便特效数据集也能使用同个标签
	- 那就没什么意义了，换回绝对路径好了
- [ ] 同上，一些对数据集文件的操作会破坏标注信息的完整性，最好还是提供规范的数据集操作接口
	- [x] 将 `to_xxx_face.py` 的标签文件更新操作抽象成根据版本的不同接口
	- [x] 只通过数据类的 `pipeline` 接口来处理可以规范化，但灵活性会差不少
- [x] 使用两眼点作为旋转矫正角度或许存在一些问题：
	- 改用最新版 crop_face_v3 或 crop_face_v4 解决
- [x] 或许用 albumentations 替代 opencv 做相关接口会更快更好？
	- albumentations 不怎么方便使用，而且存在一些 bug
- [x] 目前验证数据和训练数据的标签是分离的，理论上应该统一会比较好，和数据切分相关，可以一起改进
